if select(2, UnitClass('player')) ~= 'ROGUE' then
	DisableAddOn('Assassin')
	return
end

Assassin = {}

SLASH_Assassin1, SLASH_Assassin2 = '/assassin', '/ass'

local function InitializeVariables()
	Assassin.locked = Assassin.locked == nil and false or Assassin.locked
	Assassin.scaleMain = Assassin.scaleMain == nil and 1 or Assassin.scaleMain
	Assassin.scalePrevious = Assassin.scalePrevious == nil and 0.66 or Assassin.scalePrevious
	Assassin.scaleCooldown = Assassin.scaleCooldown == nil and 0.66 or Assassin.scaleCooldown
	Assassin.frequency = Assassin.frequency == nil and 0.05 or Assassin.frequency
	Assassin.latency = Assassin.latency == nil and 0.2 or Assassin.latency
	Assassin.previous = Assassin.previous == nil and true or Assassin.previous
	Assassin.cooldown = Assassin.cooldown == nil and true or Assassin.cooldown
	Assassin.misseffect = Assassin.misseffect == nil and true or Assassin.misseffect
	Assassin.glow = Assassin.glow == nil and true or Assassin.glow
	Assassin.bossonly = Assassin.bossonly == nil and false or Assassin.bossonly
	Assassin.front = Assassin.front == nil and false or Assassin.front
	Assassin.stealth = Assassin.stealth == nil and false or Assassin.stealth
	Assassin.poison = Assassin.poison == nil and true or Assassin.poison
	Assassin.pot = Assassin.pot == nil and false or Assassin.pot
end

local events = {}
local abilityTimer, currentTime, combatStartTime, T14P = 0, 0, 0, 0
local me = UnitGUID('player')
local DetermineAbility

local assassinPanel = CreateFrame('Frame', 'assassinPanel', UIParent)
assassinPanel:SetPoint('CENTER', 0, -169)
assassinPanel:SetFrameStrata('BACKGROUND')
assassinPanel:SetSize(64, 64)
assassinPanel:Hide()
assassinPanel:RegisterForDrag('LeftButton')
assassinPanel:SetScript('OnDragStart', assassinPanel.StartMoving)
assassinPanel:SetScript('OnDragStop', assassinPanel.StopMovingOrSizing)
assassinPanel:SetMovable(true)
assassinPanel.icon = assassinPanel:CreateTexture(nil, 'BACKGROUND')
assassinPanel.icon:SetAllPoints(assassinPanel)
assassinPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
assassinPanel.border = assassinPanel:CreateTexture(nil, 'BORDER')
assassinPanel.border:SetAllPoints(assassinPanel)
assassinPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
local assassinPreviousPanel = CreateFrame('Frame', 'assassinPreviousPanel', UIParent)
assassinPreviousPanel:SetPoint('BOTTOMRIGHT', assassinPanel, 'BOTTOMLEFT', -10, -5)
assassinPreviousPanel:SetFrameStrata('BACKGROUND')
assassinPreviousPanel:SetSize(64, 64)
assassinPreviousPanel:Hide()
assassinPreviousPanel:RegisterForDrag('LeftButton')
assassinPreviousPanel:SetScript('OnDragStart', assassinPreviousPanel.StartMoving)
assassinPreviousPanel:SetScript('OnDragStop', assassinPreviousPanel.StopMovingOrSizing)
assassinPreviousPanel:SetMovable(true)
assassinPreviousPanel.icon = assassinPreviousPanel:CreateTexture(nil, 'BACKGROUND')
assassinPreviousPanel.icon:SetAllPoints(assassinPreviousPanel)
assassinPreviousPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
assassinPreviousPanel.border = assassinPreviousPanel:CreateTexture(nil, 'BORDER')
assassinPreviousPanel.border:SetAllPoints(assassinPreviousPanel)
assassinPreviousPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
local assassinCooldownPanel = CreateFrame('Frame', 'assassinCooldownPanel', UIParent)
assassinCooldownPanel:SetPoint('BOTTOMLEFT', assassinPanel, 'BOTTOMRIGHT', 10, -5)
assassinCooldownPanel:SetSize(64, 64)
assassinCooldownPanel:SetFrameStrata('BACKGROUND')
assassinCooldownPanel:Hide()
assassinCooldownPanel:RegisterForDrag('LeftButton')
assassinCooldownPanel:SetScript('OnDragStart', assassinCooldownPanel.StartMoving)
assassinCooldownPanel:SetScript('OnDragStop', assassinCooldownPanel.StopMovingOrSizing)
assassinCooldownPanel:SetMovable(true)
assassinCooldownPanel.icon = assassinCooldownPanel:CreateTexture(nil, 'BACKGROUND')
assassinCooldownPanel.icon:SetAllPoints(assassinCooldownPanel)
assassinCooldownPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
assassinCooldownPanel.border = assassinCooldownPanel:CreateTexture(nil, 'BORDER')
assassinCooldownPanel.border:SetAllPoints(assassinCooldownPanel)
assassinCooldownPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
local energyPoolText = assassinCooldownPanel:CreateFontString(nil, 'OVERLAY')
energyPoolText:SetFont('Fonts\\FRIZQT__.TTF', 12, '')
energyPoolText:SetTextColor(1, 0.96, 0.41)
energyPoolText:SetShadowOffset(1, -1)
energyPoolText:SetShadowColor(0, 0, 0, 0.8)
energyPoolText:SetPoint('CENTER', assassinCooldownPanel, 'CENTER', 0, -1)

function GetGCD()
	local startTime, duration = GetSpellCooldown(2098)
	return max(duration - (currentTime - startTime) - Assassin.latency, 0)
end

local Ability = {}
Ability.__index = Ability

function Ability.add(spellId, buff, playerCast)
	local ability = {
		spellId = spellId,
		name = GetSpellInfo(spellId),
		icon = select(3, GetSpellInfo(spellId)),
		auraTarget = buff and 'player' or 'target',
		auraFilter = (buff and 'HELPFUL' or 'HARMFUL') .. (playerCast and '|PLAYER' or '')
	}
	setmetatable(ability, Ability)
	return ability
end

function Ability:ready(seconds)
	return self:cooldown() <= max(seconds or 0, GetGCD())
end

function Ability:remains()
	local _, id, expires
	for i = 1, 40 do
		_, _, _, _, _, _, expires, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId then
			return max(expires - currentTime - Assassin.latency, 0)
		end
	end
	return 0
end

function Ability:up()
	local _, id, duration, expires
	for i = 1, 40 do
		_, _, _, _, _, duration, expires, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId then
			return duration == 0 or expires - currentTime - Assassin.latency > 0
		end
	end
end

function Ability:down()
	return not self:up()
end

function Ability:cooldown()
	local startTime, duration = GetSpellCooldown(self.spellId)
	return max(duration - (currentTime - startTime) - Assassin.latency, 0)
end

function Ability:stack()
	local _, id, count
	for i = 1, 40 do
		_, _, _, count, _, _, _, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId then
			return count
		end
	end
	return 0
end

function Ability:known()
	return GetSpellBookItemInfo(self.name) and true or false
end

function Ability:checkButtonAndGlow(button, on)
	if button then
		local actionType, spellIdOrMacro = GetActionInfo(button.action)
		if actionType and ((actionType == 'spell' and spellIdOrMacro == self.spellId) or (actionType == 'macro' and (select(2, GetMacroInfo(spellIdOrMacro))) == self.icon)) then
			if on then
				ActionButton_ShowOverlayGlow(button)
			else
				ActionButton_HideOverlayGlow(button)
			end
		end
	end
end

function Ability:glow(on)
	for i = 1, 12 do
		self:checkButtonAndGlow(_G['ActionButton' .. i], on)
		self:checkButtonAndGlow(_G['MultiBarLeftButton' .. i], on)
		self:checkButtonAndGlow(_G['MultiBarRightButton' .. i], on)
		self:checkButtonAndGlow(_G['MultiBarBottomLeftButton' .. i], on)
		self:checkButtonAndGlow(_G['MultiBarBottomRightButton' .. i], on)
	end
	if Dominos then
		for i = 1, 60 do
			self:checkButtonAndGlow(_G['DominosActionButton' .. i], on)
		end
	end
end

-- Rogue abilities
local AdrenalineRush = Ability.add(13750, true, true)
local Ambush = Ability.add(8676, false, true)
local Anticipation = Ability.add(115189, true, true)
local Backstab = Ability.add(53, false, true)
local BanditsGuile = Ability.add(84654, true, true)
local DeadlyPoison = Ability.add(2823, true, true)
local DeepInsight = Ability.add(84747, true, true)
local Dispatch = Ability.add(111240, false, true)
local Envenom = Ability.add(32645, true, true)
local Eviscerate = Ability.add(2098, false, true)
local FindWeakness = Ability.add(91021, false, true)
local Hemorrhage = Ability.add(89775, false, true)
local KillingSpree = Ability.add(51690, true, true)
local MarkedForDeath = Ability.add(137619, false, true)
local MasterOfSubtlety = Ability.add(31223, true, true)
local ModerateInsight = Ability.add(84746, true, true)
local Mutilate = Ability.add(1329, false, true)
local Premeditation = Ability.add(14183, true, true)
local Preparation = Ability.add(14185, true, true)
local RevealingStrike = Ability.add(84617, false, true)
local Rupture = Ability.add(1943, false, true)
local ShadowBlades = Ability.add(121471, true, true)
local ShadowDance = Ability.add(51713, true, true)
local ShadowFocus = Ability.add(108209, true, true)
local ShallowInsight = Ability.add(84745, true, true)
local ShurikenToss = Ability.add(114014, false, true)
local SinisterStrike = Ability.add(1752, false, true)
local SliceAndDice = Ability.add(5171, true, true)
local Stealth = Ability.add(1784, true, true)
local Subterfuge = Ability.add(108208, true, true)
local TricksOfTheTrade = Ability.add(57934, true, true)
local Vanish = Ability.add(1856, true, true)
local Vanished = Ability.add(11327, true, true)
local Vendetta = Ability.add(79140, false, true)
-- Potions
local VirmensBite = Ability.add(105697, true, true)
-- Non-existent spell
local NoSpell, PoolSpell = Ability.add(0), Ability.add(0)
PoolSpell.icon = 'Interface\\AddOns\\Assassin\\poolspell.blp'

local abilityNow, oldAbilityNow, abilityPrevious, abilityCD = NoSpell, NoSpell, NoSpell, NoSpell

local function ComboPoints()
	return GetComboPoints('player', 'target')
end

local EnergyRegen = GetPowerRegen

local function Energy()
	return min(UnitPower('player') + (EnergyRegen() * Assassin.latency), UnitPowerMax('player'))
end

local function EnergyTimeToMax()
	return (100 - Energy()) / EnergyRegen()
end

local InCombat = InCombatLockdown

local function InGroup()
	return UnitInParty('party1')
end

local function PoolEnergy(amount)
	energyPoolText:SetText(max(floor(amount - Energy()), 0))
	return PoolSpell
end

local function Speeding()
	local _, id
	for i = 1, 40 do
		_, _, _, _, _, _, _, _, _, _, id = UnitAura('player', i, 'HELPFUL')
		if id == 2825 or id == 32182 or id == 80353 or id == 90355 then
			return true
		end
	end
end

local function Stealthed()
	return Stealth:up() or Vanished:up() or ShadowDance:up()
end

local function TimeInCombat()
    return combatStartTime > 0 and currentTime - combatStartTime + Assassin.latency or 0
end

local Target = {
	boss = false,
	healthArray = {},
	hostile = false,
}

Target.healthPercentage = function()
	return UnitHealth('target') / UnitHealthMax('target') * 100
end

Target.timeToDie = function()
	local ttd = UnitHealth('target') / ((Target.healthArray[1] - Target.healthArray[#Target.healthArray]) / 3) - Assassin.latency
	return ttd >= 0 and ttd or 600
end

BanditsGuile._stack = 0

function BanditsGuile:stack()
	return self._stack
end

function Dispatch:available()
	return Target.healthPercentage() < 35 or select(4, GetSpellInfo(self.spellId)) == 0
end

function VirmensBite:cooldown()
	local startTime, duration = GetItemCooldown(76089)
	return max(duration - (currentTime - startTime) - Assassin.latency, 0)
end

local function DetermineAbilityAssassination()
	if Assassin.cooldown and (not Assassin.bossonly or Target.boss) then
		if Preparation:ready() and not (Vanish:up() or Vanish:ready(60)) then
			abilityCD = Preparation
		elseif Vanish:ready() and TimeInCombat() > 10 and not (Stealthed() or ShadowBlades:up()) then
			abilityCD = Vanish
		elseif ShadowBlades:ready() and (TimeInCombat() > 60 or Speeding()) then	
			abilityCD = ShadowBlades
		elseif MarkedForDeath:known() and ComboPoints() == 0 and MarkedForDeath:ready() then
			abilityCD = MarkedForDeath
		elseif Vendetta:ready() then
			abilityCD = Vendetta
		elseif Assassin.pot and Target.boss and VirmensBite:ready() and (Speeding() or Target.timeToDie() < 40) then
			abilityCD = VirmensBite
		elseif TricksOfTheTrade:ready() and InGroup() then
			abilityCD = TricksOfTheTrade
		else
			abilityCD = NoSpell
		end
	else
		abilityCD = NoSpell
	end
	if not InCombat() then
		if Assassin.poison and DeadlyPoison:remains() < 300 then
			return DeadlyPoison
		elseif Assassin.stealth and not Stealthed() then
			return Stealth
		end
	end
	if Stealthed() then
		return Ambush
	elseif SliceAndDice:remains() < 2 and ComboPoints() ~= 0 then
		return SliceAndDice
	elseif Rupture:remains() < 2 and Energy() > 90 and ComboPoints() < 5 then
		return Dispatch:available() and Dispatch or Mutilate
	elseif (Rupture:remains() < 4 and ComboPoints() ~= 0) or (ComboPoints() == 5 and Rupture:remains() < 6) then
		return Rupture
	elseif ComboPoints() == 5 or (ComboPoints() >= 2 and SliceAndDice:remains() < 3) then
		return Envenom
	elseif ComboPoints() < 5 and Dispatch:available() then
		return Dispatch
	end
	return Mutilate
end

local function DetermineAbilityCombat()
	if Assassin.cooldown and (not Assassin.bossonly or Target.boss) then
		if Preparation:ready() and not (Vanish:up() or Vanish:ready(60)) then
			abilityCD = Preparation
		elseif Vanish:ready() and TimeInCombat() > 10 and (ComboPoints() < 3 or (Anticipation:known() and Anticipation:stack() < 3) or (ShadowBlades:down() and (ComboPoints() < 4 or (Anticipation:known() and Anticipation:stack() < 4)))) and ((ShadowFocus:known() and AdrenalineRush:down() and Energy() <= 30) or (Subterfuge:known() and Energy() >= 90) or (not (ShadowFocus:known() or Subterfuge:known()) and Energy() >= 60)) then
			abilityCD = Vanish
		elseif ShadowBlades:ready() and ((T14P < 4 and TimeInCombat() > 5) or (T14P >= 4 and ((not KillingSpree:ready(30.5) and AdrenalineRush:ready(9)) or (Energy() < 35 and (KillingSpree:ready() or AdrenalineRush:ready()))))) then
			abilityCD = ShadowBlades
		elseif KillingSpree:ready() and ((T14P < 4 and Energy() < 35 and AdrenalineRush:down()) or (T14P >= 4 and ((ShadowBlades:up() and AdrenalineRush:down() and (Energy() < 35 or ShadowBlades:remains() <= 3.5)) or (ShadowBlades:down() and not ShadowBlades:ready(30))))) then
			abilityCD = KillingSpree
		elseif AdrenalineRush:ready() and ((T14P < 4 and (Energy() < 35 or ShadowBlades:up())) or (T14P >= 4 and ShadowBlades:up() and (Energy() < 35 or ShadowBlades:remains() <= 15))) then
			abilityCD = AdrenalineRush
		elseif MarkedForDeath:known() and MarkedForDeath:ready() and ComboPoints() == 0 and RevealingStrike:up() then
			abilityCD = MarkedForDeath
		elseif Assassin.pot and Target.boss and VirmensBite:ready() and (Speeding() or Target.timeToDie() < 40) then
			abilityCD = VirmensBite
		elseif TricksOfTheTrade:ready() and InGroup() then
			abilityCD = TricksOfTheTrade
		else
			abilityCD = NoSpell
		end
	else
		abilityCD = NoSpell
	end
	if not InCombat() then
		if Assassin.poison and DeadlyPoison:remains() < 300 then
			return DeadlyPoison
		elseif Assassin.stealth and not Stealthed() then
			return Stealth
		end
	end
	if Stealthed() then
		return Ambush
	elseif (ComboPoints() ~= 0 and SliceAndDice:remains() < 2) or (SliceAndDice:remains() < 15 and BanditsGuile:stack() == 11 and ComboPoints() >= 4) then
		return SliceAndDice
	elseif ComboPoints() < 5 or (Anticipation:known() and Anticipation:stack() <= 4 and RevealingStrike:down()) then
		if RevealingStrike:remains() < 2 then
			return RevealingStrike
		else
			return SinisterStrike
		end
	elseif not Anticipation:known() or DeepInsight:up() or ShadowBlades:ready(11) or Anticipation:stack() >= 4 or (ShadowBlades:up() and Anticipation:stack() >= 3) then
		if Rupture:remains() < 4 and Target.timeToDie() >= 26 then
			return Rupture
		else
			return Eviscerate
		end
	elseif Energy() > 60 or DeepInsight:down() or DeepInsight:remains() > 5 - ComboPoints() then
		if RevealingStrike:remains() < 2 then
			return RevealingStrike
		else
			return SinisterStrike
		end
	end
	return NoSpell
end

local function DetermineAbilitySubtlety()
	if Assassin.cooldown and InCombat() and (not Assassin.bossonly or Target.boss) then
		if ShadowBlades:ready() then
			abilityCD = ShadowBlades
		elseif ShadowDance:ready() and not (Stealthed() or FindWeakness:up()) then
			abilityCD = Energy() >= 75 and ShadowDance or PoolEnergy(75)
		elseif Vanish:ready() and Energy() <= 75 and ComboPoints() <= 3 and not (ShadowDance:up() or MasterOfSubtlety:up() or FindWeakness:up()) then
			abilityCD = Energy() >= 45 and Vanish or PoolEnergy(45)
		elseif MarkedForDeath:known() and MarkedForDeath:ready() and ComboPoints == 0 then
			abilityCD = MarkedForDeath
		elseif Preparation:ready() and not (Vanish:up() or Vanish:ready(60) or MasterOfSubtlety:up() or ShadowDance:up() or FindWeakness:up()) and (Energy() + ShadowDance:cooldown() * EnergyRegen() < 80 or Energy() + Vanish:cooldown() * EnergyRegen() < 60) then
			abilityCD = Preparation
		elseif Assassin.pot and Target.boss and VirmensBite:ready() and (Speeding() or Target.timeToDie() < 40) then
			abilityCD = VirmensBite
		elseif TricksOfTheTrade:ready() and InGroup() then
			abilityCD = TricksOfTheTrade
		else
			abilityCD = NoSpell
		end
	else
		abilityCD = NoSpell
	end
	if not InCombat() then
		if Assassin.poison and DeadlyPoison:remains() < 300 then
			return DeadlyPoison
		elseif Assassin.stealth and not Stealthed() then
			return Stealth
		elseif Premeditation:ready() and Stealthed() and ComboPoints() < 4 then
			return Premeditation
		elseif SliceAndDice:remains() < 6 and ComboPoints() ~= 0 then
			return SliceAndDice
		end
	end
	if Premeditation:ready() and Stealthed() and (ComboPoints() < 3 or (Anticipation:known() and Anticipation:stack() < 3)) then
		return Premeditation
	elseif Stealthed() and (ComboPoints() < 5 or (Anticipation:known() and Anticipation:stack() < 3)) then
		return Ambush
	elseif Anticipation:known() and Anticipation:stack() < 4 and SliceAndDice:up() and Rupture:remains() > 2 and (SliceAndDice:remains() < 6 or Rupture:remains() < 4) then
		if Hemorrhage:remains() < 3 or Assassin.front then
			return Hemorrhage
		elseif ShurikenToss:known() and (Energy() < 65 and EnergyRegen() < 16) then
			return ShurikenToss
		else
			return Backstab
		end
	elseif ComboPoints() == 5 then
		if SliceAndDice:remains() < 4 then
			return SliceAndDice
		elseif Rupture:remains() < 4 then
			return Rupture
		else
			return Eviscerate
		end
	elseif ComboPoints() < 4 or Energy() > 80 or Anticipation:known() then
		if Hemorrhage:remains() < 3 or Assassin.front then
			return Hemorrhage
		elseif ShurikenToss:known() and (Energy() < 65 and EnergyRegen() < 16) then
			return ShurikenToss
		else
			return Backstab
		end
	end
	return NoSpell
end

function events:PLAYER_TARGET_CHANGED()
	local previouslyHostile = Target.hostile
	Target.hostile = UnitCanAttack('player', 'target') and not UnitInVehicle('player')
	if Target.hostile then
		Target.level = UnitLevel('target')
		Target.boss = Target.level == -1 or (Target.level >= 92 and not UnitInRaid('player'))
		for i = 1, #Target.healthArray do
			Target.healthArray[i] = UnitHealth('target')
		end
		abilityTimer = Assassin.frequency
		assassinPanel:Show()
	elseif previouslyHostile then
		if Assassin.glow then
			abilityNow:glow(false)
			abilityCD:glow(false)
		end
		abilityNow = NoSpell
		abilityCD = NoSpell
		assassinPanel:Hide()
		assassinPreviousPanel:Hide()
		assassinCooldownPanel:Hide()
	end
end

function events:UNIT_FACTION(unitID)
	if unitID == 'target' then
		events:PLAYER_TARGET_CHANGED()
	end
end

local function NoDetermineAbility()
	abilityCD = NoSpell
	return NoSpell
end

function events:ACTIVE_TALENT_GROUP_CHANGED()
	local spec = GetSpecialization()
	DetermineAbility = spec == 1 and DetermineAbilityAssassination or spec == 2 and DetermineAbilityCombat or spec == 3 and DetermineAbilitySubtlety or NoDetermineAbility
end

local function Equipped(slot, item)
	return (GetInventoryItemLink('player', slot) or ''):match('%[([^%]]*)%]') == item and 1 or 0
end

function events:PLAYER_EQUIPMENT_CHANGED()
	T14P = Equipped(1, 'Helmet of the Thousandfold Blades') + Equipped(3, 'Spaulders of the Thousandfold Blades') + Equipped(5, 'Tunic of the Thousandfold Blades') + Equipped(7, 'Legguards of the Thousandfold Blades') + Equipped(10, 'Gloves of the Thousandfold Blades')
end

function events:PLAYER_LOGIN()
	events:ACTIVE_TALENT_GROUP_CHANGED()
	events:PLAYER_EQUIPMENT_CHANGED()
end

function events:ZONE_CHANGED_NEW_AREA()
	events:PLAYER_EQUIPMENT_CHANGED()
	assassinPanel:UnregisterEvent('ZONE_CHANGED_NEW_AREA')
end

function events:PLAYER_REGEN_DISABLED()
    combatStartTime = GetTime()
end

function events:PLAYER_REGEN_ENABLED()
    combatStartTime = 0
end

function events:ADDON_LOADED(name)
	if name == 'Assassin' then
		if not Assassin.frequency then
			print('It looks like this is your first time running Assassin, why don\'t you take some time to familiarize yourself with the commands?')
			print('Type |cFFFFD000/assassin|r for a list of commands.')
		end
		InitializeVariables()
		assassinPanel:SetScale(Assassin.scaleMain)
		assassinPanel:EnableMouse(not Assassin.locked)
		assassinPreviousPanel:SetScale(Assassin.scalePrevious)
		assassinPreviousPanel:EnableMouse(not Assassin.locked)
		assassinCooldownPanel:SetScale(Assassin.scaleCooldown)
		assassinCooldownPanel:EnableMouse(not Assassin.locked)
		for i = 1, floor(3 / Assassin.frequency) do
			Target.healthArray[i] = 0
		end
	end
end

function events:UNIT_SPELLCAST_SENT(srcName, spellName)
	if Assassin.previous and srcName == 'player' and spellName == abilityNow.name then
		abilityPrevious = abilityNow
	end
end

function events:COMBAT_LOG_EVENT_UNFILTERED(self, eventType, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, spellId, spellName, spellSchool, auraType)
	if srcGUID == me then
		if eventType == 'SPELL_CAST_SUCCESS' then
			if Assassin.previous and spellId == abilityPrevious.spellId then
				assassinPreviousPanel.icon:SetTexture(abilityPrevious.icon)
				assassinPreviousPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
				assassinPreviousPanel:Show()
			end
			if (spellId == SinisterStrike.spellId or spellId == RevealingStrike.spellId) and BanditsGuile._stack < 12 then
				BanditsGuile._stack = BanditsGuile._stack + 1
			end
		elseif eventType == 'SPELL_AURA_APPLIED' and dstGUID == me then
			if spellId == ShallowInsight.spellId then
				BanditsGuile._stack = 4
			elseif spellId == ModerateInsight.spellId then
				BanditsGuile._stack = 8
			elseif spellId == DeepInsight.spellId then
				BanditsGuile._stack = 12
			end
		elseif eventType == 'SPELL_AURA_REMOVED' and dstGUID == me and (spellId == ShallowInsight.spellId or spellId == ModerateInsight.spellId or spellId == DeepInsight.spellId) then
			BanditsGuile._stack = 0
		elseif Assassin.previous and Assassin.misseffect and eventType == 'SPELL_MISSED' and spellId == abilityPrevious.spellId then
			assassinPreviousPanel.border:SetTexture('Interface\\AddOns\\Assassin\\misseffect.blp')
		end
	end
end

assassinPanel:SetScript('OnUpdate', function(self, elapsed)
	abilityTimer = abilityTimer + elapsed
	if abilityTimer >= Assassin.frequency then
		Target.healthArray[#Target.healthArray + 1] = UnitHealth('target')
		table.remove(Target.healthArray, 1)
		oldAbilityNow = abilityNow
		oldAbilityCD = abilityCD
		currentTime = GetTime()
		abilityNow = DetermineAbility()
		if abilityNow ~= oldAbilityNow then
			if abilityNow.icon then
				assassinPanel.icon:SetTexture(abilityNow.icon)
				assassinPanel.icon:Show()
				assassinPanel.border:Show()
			else
				assassinPanel.icon:Hide()
				assassinPanel.border:Hide()
			end
			if Assassin.glow then
				oldAbilityNow:glow(false)
			end
		end
		if abilityCD ~= oldAbilityCD then
			if abilityCD.icon then
				assassinCooldownPanel.icon:SetTexture(abilityCD.icon)
				assassinCooldownPanel:Show()
			else
				assassinCooldownPanel:Hide()
			end
			if Assassin.glow then
				oldAbilityCD:glow(false)
			end
			if oldAbilityCD == PoolSpell then
				energyPoolText:SetText('')
			end
		end
		if Assassin.glow then
			abilityNow:glow(true)
			abilityCD:glow(true)
		end
		abilityTimer = 0
	end
end)

assassinPanel:SetScript('OnEvent', function(self, event, ...) events[event](self, ...) end)
for event in pairs(events) do
	assassinPanel:RegisterEvent(event)
end

function SlashCmdList.Assassin(msg, editbox)
	msg = { strsplit(' ', strlower(msg)) }
	if msg[1] == 'locked' then
		if msg[2] then
			Assassin.locked = msg[2] == 'on'
			assassinPanel:EnableMouse(not Assassin.locked and assassinPanel.icon:IsVisible())
			assassinPreviousPanel:EnableMouse(not Assassin.locked)
			assassinCooldownPanel:EnableMouse(not Assassin.locked)
		end
		print('Assassin - Locked: ' .. (Assassin.locked and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'scale' then
		if msg[2] == 'prev' then
			if msg[3] then
				Assassin.scalePrevious = tonumber(msg[3]) or 0.66
				assassinPreviousPanel:SetScale(Assassin.scalePrevious)
			end
			print('Assassin - Previous ability icon scale set to: |cFFFFD000' .. Assassin.scalePrevious .. '|r times')
		elseif msg[2] == 'main' then
			if msg[3] then
				Assassin.scaleMain = tonumber(msg[3]) or 1
				assassinPanel:SetScale(Assassin.scaleMain)
			end
			print('Assassin - Main ability icon scale set to: |cFFFFD000' .. Assassin.scaleMain .. '|r times')
		elseif msg[2] == 'cd' then
			if msg[3] then
				Assassin.scaleCooldown = tonumber(msg[3]) or 0.66
				assassinCooldownPanel:SetScale(Assassin.scaleCooldown)
			end
			print('Assassin - Cooldown ability icon scale set to: |cFFFFD000' .. Assassin.scaleCooldown .. '|r times')
		else
			print('Assassin - Default icon scale options are |cFFFFD000prev 0.66|r, |cFFFFD000main 1|r, and |cFFFFD000cd 0.66|r')
		end
	elseif msg[1] == 'frequency' then
		if msg[2] then Assassin.frequency = tonumber(msg[2]) or 0.05 end
		print('Assassin - Calculation frequency: Every |cFFFFD000' .. Assassin.frequency .. '|r seconds')
	elseif msg[1] == 'latency' then
		if msg[2] then Assassin.latency = tonumber(msg[2]) or 0.3 end
		print('Assassin - Player reaction time: |cFFFFD000' .. Assassin.latency .. '|r seconds')
	elseif msg[1] == 'glow' then
		if msg[2] then
			Assassin.glow = msg[2] == 'on'
			abilityNow:glow(Assassin.glow)
			abilityCD:glow(Assassin.glow)
		end
		print('Assassin - Glowing ability buttons: ' .. (Assassin.glow and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'previous' then
		if msg[2] then Assassin.previous = msg[2] == 'on' end
		print('Assassin - Previous ability icon: ' .. (Assassin.previous and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'cooldown' then
		if msg[2] then Assassin.cooldown = msg[2] == 'on' end
		print('Assassin - Cooldown ability icon: ' .. (Assassin.cooldown and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'misseffect' then
		if msg[2] then Assassin.misseffect = msg[2] == 'on' end
		print('Assassin - Red border around previous ability icon on failure to hit: ' .. (Assassin.misseffect and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'bossonly' then
		if msg[2] then Assassin.bossonly = msg[2] == 'on' end
		print('Assassin - Only use cooldowns on bosses: ' .. (Assassin.bossonly and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'front' then
		if msg[2] then Assassin.front = msg[2] == 'on' end
		print('Assassin - In front of enemy (can\'t Backstab): ' .. (Assassin.front and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'stealth' then
		if msg[2] then Assassin.stealth = msg[2] == 'on' end
		print('Assassin - Show reminder to Stealth pre-combat: ' .. (Assassin.stealth and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'poison' then
		if msg[2] then Assassin.poison = msg[2] == 'on' end
		print('Assassin - Show 5 minute reminder for Deadly Poison: ' .. (Assassin.poison and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'pot' then
		if msg[2] then Assassin.pot = msg[2] == 'on' end
		print('Assassin - Show Virmen\'s Bite potions in cooldown UI: ' .. (Assassin.pot and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'reset' then
		assassinPanel:ClearAllPoints()
		assassinPanel:SetPoint('CENTER', 0, -169)
		assassinPreviousPanel:ClearAllPoints()
		assassinPreviousPanel:SetPoint('BOTTOMRIGHT', assassinPanel, 'BOTTOMLEFT', -10, -5)
		assassinCooldownPanel:ClearAllPoints()
		assassinCooldownPanel:SetPoint('BOTTOMLEFT', assassinPanel, 'BOTTOMRIGHT', 10, -5)
		print('Assassin - Position has been reset to default')
	else
		print('Assassin (version: |cFFFFD000' .. GetAddOnMetadata('Assassin', 'Version') .. '|r) - Commands:')
		print('  /assassin locked |cFF00C000on|r/|cFFC00000off|r - lock the Assassin UI icons so that they can\'t be moved')
		print('  /assassin scale |cFFFFD000prev|r/|cFFFFD000main|r/|cFFFFD000cd|r |cFFFFD000[number]|r - adjust the scale of the Assassin UI icons')
		print('  /assassin frequency |cFFFFD000[number]|r - set the calculation frequency (default is every 0.05 seconds)')
		print('  /assassin latency |cFFFFD000[number]|r - player\'s reaction time (default is 0.2 seconds)')
		print('  /assassin glow |cFF00C000on|r/|cFFC00000off|r - glowing ability buttons on action bars')
		print('  /assassin previous |cFF00C000on|r/|cFFC00000off|r - previous ability icon')
		print('  /assassin cd |cFF00C000on|r/|cFFC00000off|r - cooldown ability icon (turn off for manual cooldown management)')
		print('  /assassin misseffect |cFF00C000on|r/|cFFC00000off|r - red border around previous ability icon on failure to hit')
		print('  /assassin bossonly |cFF00C000on|r/|cFFC00000off|r - only use cooldowns on bosses')
		print('  /assassin front |cFF00C000on|r/|cFFC00000off|r - in front of enemy (can\'t Backstab)')
		print('  /assassin stealth |cFF00C000on|r/|cFFC00000off|r - show reminder to Stealth pre-combat')
		print('  /assassin poison |cFF00C000on|r/|cFFC00000off|r - show 5 minute reminder for Deadly Poison')
		print('  /assassin pot |cFF00C000on|r/|cFFC00000off|r - show Virmen\'s Bite potions in cooldown icon')
		print('  /assassin |cFFFFD000reset|r - reset the location of the Assassin UI icons to default')
		if Claw_Resources then
			print('For Claw Resources commands, please type |cFFFFD000/cres|r.')
		end
	end
end
